//=============================================================================
//
// file :         Standa8SMC3Class.h
//
// description :  Include for the Standa8SMC3Class root class.
//                This class is represents the singleton class for
//                the Standa8SMC3 device class.
//                It contains all properties and methods which the 
//                Standa8SMC3 requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.1 $
//
// $Log: Standa8SMC3Class.h,v $
// Revision 1.1  2014-09-22 13:21:58  graziano
// first commit
//
// Revision 1.3  2009-09-23 15:11:26  graziano
// added attribute Position_home
//
// Revision 1.2  2009/04/02 13:45:48  graziano
// added command find_edge
//
// Revision 1.1  2008/11/19 10:39:26  graziano
// first version
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _STANDA8SMC3CLASS_H
#define _STANDA8SMC3CLASS_H

#include <tango.h>
#include <Standa8SMC3.h>


namespace Standa8SMC3_ns
{//=====================================
//	Define classes for attributes
//=====================================
class SpeedAttrib: public Tango::SpectrumAttr
{
public:
	SpeedAttrib():SpectrumAttr("Speed", Tango::DEV_DOUBLE, Tango::READ_WRITE, 2) {};
	~SpeedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->read_Speed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->write_Speed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Speed_allowed(ty);}
};

class Position_homeAttrib: public Tango::Attr
{
public:
	Position_homeAttrib():Attr("Position_home", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Position_homeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->read_Position_home(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->write_Position_home(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Position_home_allowed(ty);}
};

class AccuracyAttrib: public Tango::Attr
{
public:
	AccuracyAttrib():Attr("Accuracy", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AccuracyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->read_Accuracy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->write_Accuracy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Accuracy_allowed(ty);}
};

class AccelerationAttrib: public Tango::Attr
{
public:
	AccelerationAttrib():Attr("Acceleration", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AccelerationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->read_Acceleration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->write_Acceleration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Acceleration_allowed(ty);}
};

class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PositionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Position_allowed(ty);}
};

class StatAttrib: public Tango::Attr
{
public:
	StatAttrib():Attr("Stat", Tango::DEV_LONG, Tango::READ) {};
	~StatAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Standa8SMC3 *>(dev))->read_Stat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Stat_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class FindEdgeClass : public Tango::Command
{
public:
	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	FindEdgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~FindEdgeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_FindEdge_allowed(any);}
};



class GoToPositionClass : public Tango::Command
{
public:
	GoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoToPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_GoToPosition_allowed(any);}
};



class SetHomeClass : public Tango::Command
{
public:
	SetHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_SetHome_allowed(any);}
};



class GoHomeClass : public Tango::Command
{
public:
	GoHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GoHomeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GoHomeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_GoHome_allowed(any);}
};



class MotorSTANDBYClass : public Tango::Command
{
public:
	MotorSTANDBYClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorSTANDBYClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorSTANDBYClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_MotorSTANDBY_allowed(any);}
};



class MotorONClass : public Tango::Command
{
public:
	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_MotorON_allowed(any);}
};



class MotorOFFCmd : public Tango::Command
{
public:
	MotorOFFCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_MotorOFF_allowed(any);}
};



class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Stop_allowed(any);}
};



class BackwardCmd : public Tango::Command
{
public:
	BackwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BackwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BackwardCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Backward_allowed(any);}
};



class ForwardCmd : public Tango::Command
{
public:
	ForwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForwardCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForwardCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Standa8SMC3 *>(dev))->is_Forward_allowed(any);}
};



//
// The Standa8SMC3Class singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	Standa8SMC3Class : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static Standa8SMC3Class *init(const char *);
	static Standa8SMC3Class *instance();
	~Standa8SMC3Class();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	Standa8SMC3Class(string &);
	static Standa8SMC3Class *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Standa8SMC3_ns

#endif // _STANDA8SMC3CLASS_H
